#!/usr/local/psa/bin/sw-engine-pleskrun
<?php
/*
    Commtouch Outbound Spam and Virus protection for Parallels Plesk
    Coded by Gabriel M. Mizrahi <gabriel@commtouch.com>
    Copyright (c) 2012, Commtouch Software Ltd.
/*

/*
Log example for Qmail:
Jan 23 18:59:00 linuxpc qmail-ctasd[30381]: OUT|IN IP: 172.20.20.222, From: root@calamar, sClass: Unknown, vClass: Unknown, 
   >>> RefID: str=0001.0A0B020A.4F1D91E2.00C7,ss=1,re=0.000,fgs=0, SenderID: test@test.commtouch.com, Flags: 0, TMsg: 1, TSpam: 0, TSus: 0, TVirus: 0

Log example for Postfix:
Feb 12 20:04:03 commtouch ct-milter[6578]: [ASVOD] OUT|IN IP: 218.102.23.45, Sender(Auth): <void-bounce-toppatty=netvigator.com@express.medallia.com>((null)), 
   >>> Spam: Unknown, VOD: Unknown, RefID: str=0001.0A020201.4F37AAB3.0044:SCFSTAT1403659,ss=1,re=-4.000,recu=0.000,reip=0.000,cl=1,cld=1,fgs=0, 
   >>> Action: tag, Reason: global-policy, QueueId: unknown, SenderID: test@test.commtouch.com, Flags: 0, TMsg: 1, TSpam: 0, TSus: 0, TVirus: 0

Naming convention:

<BASEDIR>/<Year>/[h|d|w]YYmmdd(HH){.part}
    ^       ^      ^      ^         ^
    |       |      |      |         ----- extension for partial hour (hour didn't lap)
    |       |      |      --------------- Date with hour resolution, statistics represent the HH hour (HH:00 until HH:59).
    |	    |	   |                      Daily statistics are generated for the last full hour process to reflect last 24 hours.
    |       |      ---------------------- h = Hourly statistics; d = Daily statistics.
    |       ----------------------------- Year subfolder
    ------------------------------------- Commtouch's statistics collection subfolder
1st two lines = global numbers:
"Spam",NonSpam,Unknown,Suspect,Bulk,Confirmed
"Virus",NonVirus,Unknown,Medium,High,Virus
3rd and up: SenderID-based:
SenderID,TotalSpam,TotalVirus,TotalMessages,TotalSpam[NonSpam,Unknown,Suspect,Bulk,Confirmed],TotalVirus[NonVirus,Unknown,Medium,High,Virus]

*/

define("DEBUGLEVEL",0);

function debug($level,$string){
    if ($level<=DEBUGLEVEL)
	echo date("d-m-Y G:i:s",time()).": ".$string."\n";
}

function setTimezoneByOffset($offset) { 
        $testTimestamp = time(); 
        $mydate = explode(":",shell_exec('date +%H":"%M":"%S'));
	$refHour = $mydate[0];
	$refMin = $mydate[1];

      
    $abbrarray = timezone_abbreviations_list(); 
    foreach ($abbrarray as $abbr) 
    { 
        //echo $abbr."<br>"; 
      foreach ($abbr as $city) 
      { 
                @date_default_timezone_set($city['timezone_id']); 
                $testLocaltime     = localtime($testTimestamp,true); 
                $hour                     = $testLocaltime['tm_hour'];        
                $min                     = $testLocaltime['tm_min'];        
            if (($hour == $refHour) && ((abs($refMin-$min)<5) || (abs($refMin-$min>55)))) {
//            	    print_r($city);
                    return true; 
                } 
      } 
    } 
    return false; 
} 

function setLocalTimezone()
{
    //date_default_timezone_set('UTC'); 
    $iTime = time();
    $arr = @localtime($iTime);
    $arr[5] += 1900; 
    $arr[4]++;
    $iTztime = gmmktime($arr[2], $arr[1], $arr[0], $arr[4], $arr[3], $arr[5], $arr[8]);
    $offset = doubleval(($iTztime-$iTime)/(60*60));
    setTimezoneByOffset($offset);
}

setLocalTimezone();


//date_default_timezone_set('UTC+2');
error_reporting(0);

$sClass=array(0=>"NonSpam",1=>"Unknown",2=>"Suspect",3=>"Bulk",4=>"Confirmed");
$vClass=array(0=>"NonVirus",1=>"Unknown",2=>"Medium",3=>"High",4=>"Virus");

// dot partial file = don't have all data...

define("BASEDIR","/var/log/ctchob/");
define("SENDERID_LIMIT",5000);
define("MINUTE",60);
define("HOUR",MINUTE*60);
define("DAY",HOUR*24);
define("WEEK",DAY*7);

$lastepoch=0; 
$prevdateh="";
$skiph=false;

if (!file_exists(BASEDIR))
    mkdir (BASEDIR);

function reset_arrays() {
    global $arr_sClass,$arr_vClass,$arr_sSenderID,$arr_vSenderID,$arr_tSenderID,$arr_SenderID;
    $arr_sClass=array();
    $arr_vClass=array();
    $arr_SenderID=array();
    $arr_sSenderID=array();
    $arr_vSenderID=array();
    $arr_tSenderID=array();
}


function dumpfile($file) {
    global $sClass,$vClass,$arr_sClass,$arr_vClass,$arr_sSenderID,$arr_vSenderID,$arr_tSenderID,$arr_SenderID;
    // let's dump the data
    $fg=fopen($file,"w");
    $sStr="Spam";   
    for ($i=0; $i<sizeof($sClass); $i++) {
	if (!isset($arr_sClass[$sClass[$i]]))
	    $arr_sClass[$sClass[$i]]='0';
	    $sStr.=",".$arr_sClass[$sClass[$i]];
    }
    fwrite ($fg,$sStr."\n");
    $vStr="Virus";
    for ($i=0; $i<sizeof($vClass); $i++) {
        if (!isset($arr_vClass[$vClass[$i]]))
	    $arr_vClass[$vClass[$i]]='0';
	$vStr.=",".$arr_vClass[$vClass[$i]];
    }
    fwrite ($fg,$vStr."\n");
    $sc=0;
    arsort($arr_sSenderID);
    foreach ($arr_sSenderID as $_sID => $val) {
	$sStr=preg_replace("/,/",".",$_sID).",".$val;
	if (!isset($arr_vSenderID[$_sID]))
	    $arr_vSenderID[$_sID]="0";
	$sStr.=",".$arr_vSenderID[$_sID];
	if (!isset($arr_tSenderID[$_sID]))
	    $arr_tSenderID[$_sID]="0";
	$sStr.=",".$arr_tSenderID[$_sID];
	$arr_sClass=$arr_SenderID[$_sID]["Spam"];
	$arr_vClass=$arr_SenderID[$_sID]["Virus"];
	for ($i=0; $i<sizeof($sClass); $i++) {
	    if (!isset($arr_sClass[$sClass[$i]]))
	        $arr_sClass[$sClass[$i]]='0';
	    $sStr.=",".$arr_sClass[$sClass[$i]];
	}
	for ($i=0; $i<sizeof($vClass); $i++) {
	    if (!isset($arr_vClass[$vClass[$i]]))
		$arr_vClass[$vClass[$i]]='0';
	    $sStr.=",".$arr_vClass[$vClass[$i]];
	}
	fwrite ($fg,$sStr."\n");
	if (++$sc >= SENDERID_LIMIT)
	    break;
    }
    fclose($fg);
}

function processhourpart($prevhfile) {
    if (processhour($prevhfile.".part"))
	unlink($prevhfile.".part");
}

function processhour($hfile) {
    global $sClass,$vClass,$arr_sClass,$arr_vClass,$arr_sSenderID,$arr_vSenderID,$arr_tSenderID,$arr_SenderID;
    if (!file_exists($hfile)) 
	return false;
    $fp=fopen($hfile,"r");
    $i=0;
    while (($line = fgets($fp, 4096)) !== false) {
	$line=chop($line);
	$vals=explode(",",$line);
	switch ($i) {
	    case 0:
		for ($c=0; $c<sizeof($sClass); $c++) 
		    @$arr_sClass[$sClass[$c]]+=$vals[$c+1];
		break;
	    case 1:
	        for ($c=0; $c<sizeof($vClass); $c++) 
		    @$arr_vClass[$vClass[$c]]+=$vals[$c+1];
		break;
	    default:
		foreach($vals as $k => $v) {
		    switch ($k) {
			case 0:
			    $SenderID=$v;
			    break;
			case 1:
			    @$arr_sSenderID[$SenderID]+=$v;
			    break;
			case 2:
			    @$arr_vSenderID[$SenderID]+=$v;
			    break;
			case 3:
			    @$arr_tSenderID[$SenderID]+=$v;
			    break;
			default:
			    if ($k>3 and $k<=3+sizeof($sClass)) {
        			@$arr_SenderID[$SenderID]["Spam"][$sClass[$k-4]]+=$v;
			    } elseif ($k>4+sizeof($sClass)) {
        		        @$arr_SenderID[$SenderID]["Virus"][$vClass[$k-4-sizeof($sClass)]]+=$v;
			    }
		    }
		}
	}
	$i++;
    }
    fclose($fp);
    return true;
}

debug(1,"Log parsing started");

if (file_exists(BASEDIR."lastepoch")) {
    $f=fopen(BASEDIR."lastepoch","r");
    $lastepoch=fgets($f,4096);
    fclose($f);
    $prevdateh=date("YmdH",$lastepoch);
    $prevhfile=$workdir."/h".$prevdateh;
#    processhourpart($prevhfile);
#    $skiph=false;
}
debug(10,"Last Epoch: ".$lastepoch);

foreach (array("maillog.processed","maillog") as $logfile) {
  debug (5,"Processing ".$logfile);
  $handle = @fopen("/usr/local/psa/var/log/".$logfile, "r");
  if ($handle) {
    while (($buffer = fgets($handle, 4096)) !== false) {
    	$buffer=chop($buffer);
    	$arr_val = explode(", ",$buffer);
    	$arr_date = explode(" ",$arr_val[0]);
    	$month=$arr_date[0];
    	if ($arr_date[1]) {
    	    $day=$arr_date[1];
    	    $time=$arr_date[2];
    	} else {
    	    $day=$arr_date[2];
    	    $time=$arr_date[3];
    	}
    	$year=date("Y");
    	// Let's figure out if we lapped a year...
    	$fulldate=strtotime(sprintf("%s %s, %s %s",$month,$day,$year,$time));
    	if ($fulldate>strtotime("now")) {
    	    $year--;
    	    debug (20,sprintf ("year--: %s, now: %s, fulldate: %s",$year,date(DATE_RFC822,strtotime("now")),date(DATE_RFC822,$fulldate)));
    	    $fulldate=strtotime(sprintf("%s %s, %s %s",$month,$day,$year,$time));
    	} else {
    	    debug (21,sprintf ("year: %s, now: %s, fulldate: %s",$year,date(DATE_RFC822,strtotime("now")),date(DATE_RFC822,$fulldate)));
    	}
    	$workdir=sprintf("%s%s",BASEDIR,$year);
    	$dateh=date("YmdH",$fulldate);
    	$date=date("Ymd",$fulldate);
    	if ($prevdateh!=$dateh) {
    	    if ($prevdateh!="") {
    		if (!$skiph) {
    		    $prevhfile=$workdir."/h".$prevdateh;
		    if (!file_exists($workdir))
			mkdir ($workdir);
		    
		    processhourpart($prevhfile);
		    dumpfile($prevhfile); 
		    	    
		}
		$lastfulldateh=$prevdateh;
		reset_arrays();
    	    }
    	    $hfile=$workdir."/h".$dateh;
    	    if (file_exists($hfile)) { // We already have data for the current hour, let's skip.
    		$skiph=true;
    		//printf("SKIP %s\n",$hfile);
    	    } else
    		$skiph=false;
    	    $prevdateh=$dateh;
    	}
    	
        if ((strstr($buffer,"qmail-ctasd") || (strstr($buffer,"[ASVOD]"))) && strstr($buffer,"SenderID") && !$skiph) {
    	    if ($fulldate>=$lastepoch) {
    		$arr_val[0]=preg_replace("/\[ASVOD\] /","",preg_replace("/.*\]: /","",$arr_val[0]));
            	foreach ($arr_val as $val) {
    		    list ($h,$v) = explode (": ",$val);
    		    switch ($h) {
			case "Spam"		:
			case "sClass" 	:
			    @$arr_sClass[$v]++;
			    $_sClass=$v;
			    break;
			case "VOD"		:
			case "vClass" 	:
			    @$arr_vClass[$v]++;
			    $_vClass=$v;
			    break;
		    case "SenderID" 	:
			$SenderID=$v;
			break;
			case "OUT IP"	:
			case "IN IP"	:
			case "From"	:
			case "Flags"	: // TBA: Valid Bulk counter; Sample collection counter, etc.
			case "TMsg"	:
			case "TSpam"	:
			case "TVirus"	:
			case "RefID"	: // TBA: AV
			case "QueueId"	:
			case "Action"	:
			case "Reason"	:
			default:
			    break;
		    }
        	}
            }
    	    @$arr_tSenderID[$SenderID]++;
            @$arr_SenderID[$SenderID]["Spam"][$_sClass]++;
            @$arr_SenderID[$SenderID]["Virus"][$_vClass]++;
            if (in_array($_sClass,array("Bulk","Confirmed")))
        	@$arr_sSenderID[$SenderID]++;
    	    if (($_sClass=="Suspect") && (!isset($arr_sSenderID[$SenderID])))
    		@$arr_sSenderID[$SenderID]=0;
            if (in_array($_vClass,array("High","Virus")))
        	@$arr_vSenderID[$SenderID]++;
        }
	if (($lastepoch==0) || ($lastepoch<$fulldate))
    	    $lastepoch=$fulldate;
    }
    if (!feof($handle)) {
        echo "Error: unexpected fgets() fail\n";
    }
    fclose($handle);
  }
}

// Dump the rest as partial
$prevhfile=$workdir."/h".$prevdateh;
if (!file_exists($workdir))
    mkdir ($workdir);
processhourpart($prevhfile);
dumpfile($prevhfile.".part");

// dump lastepoch
$le=fopen(BASEDIR."lastepoch","w");
fwrite($le,$lastepoch);
fclose($le);

/**************************************************************
 Aggregate daily statistics for the last full hour.
**************************************************************/

//$lastfulldateh="2012012400";

$date=substr($lastfulldateh,0,8);
$hour=substr($lastfulldateh,-2,2);
$dfile=$workdir."/d".$lastfulldateh;

if (!file_exists($dfile)) {
    debug (1,"Aggregating daily statistics");
    $epoch=strtotime($date)+$hour*HOUR;
    reset_arrays();
    for ($i=0; $i<24; $i++) {
	$year=date("Y",$epoch);
    	$workdir=sprintf("%s%s",BASEDIR,$year);
	$hfile=$workdir."/h".date("YmdH",$epoch);
	if (file_exists($hfile)) {
	    debug (10,"Aggregating file $hfile");
	    processhour($hfile);
	}
	$epoch=$epoch-HOUR;
    }
    dumpfile($dfile);

    if(file_exists($file=BASEDIR."lastday.stats"))
        unlink($file);
    symlink($dfile,$file);
    
//    printf ("fulldate %s, date %s, hour %s\n",$lastfulldateh,$date,$hour);
} else {
    debug (1,"Daily statistics file exists, skipping aggregation");
}

/**************************************************************
 Generate weekly statistics - only once a day
**************************************************************/
if ($hour==0) {
    debug (1,"It's midnight! Generating weekly statistics");
    $epoch=strtotime($date);
    $year=date("Y",$epoch);
    $workdir=sprintf("%s%s",BASEDIR,$year);
    reset_arrays();
    $wfile=$workdir."/w".date("Ymd",$epoch);
    if (!file_exists($wfile)) {
	for ($i=0; $i<(24*7); $i++) {
	    $year=date("Y",$epoch);
	    $workdir=sprintf("%s%s",BASEDIR,$year);
	    $hfile=$workdir."/h".date("YmdH",$epoch);
	    if (file_exists($hfile)) {
		processhour($hfile);
	    }
	    $epoch=$epoch-HOUR;
	}
	dumpfile($wfile);

	if(file_exists($file=BASEDIR."lastweek.stats"))
	    unlink($file);
	symlink($wfile,$file);
    }
}

debug(1,"Log parsing ended.");

?>
